#include "menu.h"
//----------------------------------------------
extern uint16_t menutim_cnt;//   
extern uint8_t button_state[5];
static uint8_t i=0;
char str1[6];
char str3[5];
//----------------------------------------------
void MainMenuProcess(void);
void BlinkItem(uint8_t ind);
void MainMenuItemProcess(unsigned char ind);
//----------------------------------------------
char str2[6][11]=
{
"MM_1 \0",
"MM_2 \0",
"MM_3 \0",
"MM_4 \0",
"MM_5 \0",
"EXIT \0"
};
MENU_StateTypeDef menu_state = MENU_STATE_IDLE;
MAIN_MENU_StateTypeDef main_menu_state = MAIN_MENU_STATE_IDLE;
//----------------------------------------------
void MenuProcess(void)
{
	switch (menu_state)
	{
		case MENU_STATE_IDLE: // 
			menu_state = MENU_STATE_WAIT;
			LCD_Clear();
			LCD_SetPos(0,0);// 
			LCD_String("MENU");
			LCD_SetPos(0,1);
			LCD_String("Press SELECT");
			break;
		case MENU_STATE_WAIT: //   
			if(button_state[Button_Select]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Select,ST_LOCKED);
				ResetButtonState(Button_Select,ST_UNPRESSURE);
				SetButtonState(Button_Select,ST_PRESSURE);
				//  
				menu_state = MENU_STATE_MAIN;
			}
			break;
		case MENU_STATE_MAIN: //  
			main_menu_state=MAIN_MENU_STATE_IDLE;
			MainMenuProcess();
			break;
	}
  HAL_Delay(50);
}
//----------------------------------------------
void MainMenuProcess(void)
{
  while (1)
  {
    switch (main_menu_state)
    {
    case MAIN_MENU_STATE_IDLE: //  
			LCD_SetPos(0,0);
			for(i=0;i<3;i++)
			{
				LCD_String(str2[i]);
			}
			LCD_SetPos(0,1);
			for(i=0;i<3;i++)
			{
				LCD_String(str2[i+3]);
			}
			HAL_Delay(50);
			ResetButtonState(Button_Select,ST_LOCKED);
			main_menu_state = MAIN_MENU_STATE_WAIT;
      break;
    case MAIN_MENU_STATE_WAIT: //  
			if(button_state[Button_Right]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Right,ST_LOCKED);
				ResetButtonState(Button_Right,ST_UNPRESSURE);
				SetButtonState(Button_Right,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Right,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM1_WAIT;
			}
      break;
    case MAIN_MENU_STATE_MM1_WAIT: //  1 
			BlinkItem(0);
			// 
			if(button_state[Button_Right]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Right,ST_LOCKED);
				ResetButtonState(Button_Right,ST_UNPRESSURE);
				SetButtonState(Button_Right,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Right,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM2_WAIT;
				LCD_SetPos(0,0);
				LCD_String(str2[0]); // 1 ,       
			}
			// 
			if(button_state[Button_Left]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Left,ST_LOCKED);
				ResetButtonState(Button_Left,ST_UNPRESSURE);
				SetButtonState(Button_Left,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Left,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_EXIT_WAIT;
				LCD_SetPos(0,0);
				LCD_String(str2[0]); // 1 ,       
			}
			// 
			if(button_state[Button_Down]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Down,ST_LOCKED);
				ResetButtonState(Button_Down,ST_UNPRESSURE);
				SetButtonState(Button_Down,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Down,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM4_WAIT;
				LCD_SetPos(0,0);
				LCD_String(str2[0]); // 1 ,       
			}
			// SELECT
			if(button_state[Button_Select]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Select,ST_LOCKED);
				ResetButtonState(Button_Select,ST_UNPRESSURE);
				SetButtonState(Button_Select,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Select,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM1;
				LCD_SetPos(0,0);
				LCD_String(str2[0]); // 1 ,       
			}
      break;
	 case MAIN_MENU_STATE_MM2_WAIT: //  2 
			BlinkItem(1);
			// 
			if(button_state[Button_Right]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Right,ST_LOCKED);
				ResetButtonState(Button_Right,ST_UNPRESSURE);
				SetButtonState(Button_Right,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Right,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM3_WAIT;
				LCD_SetPos(5,0);
				LCD_String(str2[1]); // 2 ,       
			}
			// 
			if(button_state[Button_Left]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Left,ST_LOCKED);
				ResetButtonState(Button_Left,ST_UNPRESSURE);
				SetButtonState(Button_Left,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Left,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM1_WAIT;
				LCD_SetPos(5,0);
				LCD_String(str2[1]); // 2 ,       
			}
			// 
			if(button_state[Button_Down]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Down,ST_LOCKED);
				ResetButtonState(Button_Down,ST_UNPRESSURE);
				SetButtonState(Button_Down,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Down,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM5_WAIT;
				LCD_SetPos(5,0);
				LCD_String(str2[1]); // 2 ,       
			}
			// SELECT
			if(button_state[Button_Select]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Select,ST_LOCKED);
				ResetButtonState(Button_Select,ST_UNPRESSURE);
				SetButtonState(Button_Select,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Select,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM2;
				LCD_SetPos(5,0);
				LCD_String(str2[1]); // 2 ,       
			}
      break;
    case MAIN_MENU_STATE_MM3_WAIT: //  3 
			BlinkItem(2);
			// 
			if(button_state[Button_Right]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Right,ST_LOCKED);
				ResetButtonState(Button_Right,ST_UNPRESSURE);
				SetButtonState(Button_Right,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Right,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM4_WAIT;
				LCD_SetPos(10,0);
				LCD_String(str2[2]); // 3 ,       
			}
			// 
			if(button_state[Button_Left]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Left,ST_LOCKED);
				ResetButtonState(Button_Left,ST_UNPRESSURE);
				SetButtonState(Button_Left,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Left,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM2_WAIT;
				LCD_SetPos(10,0);
				LCD_String(str2[2]); // 3 ,       
			}
			// 
			if(button_state[Button_Down]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Down,ST_LOCKED);
				ResetButtonState(Button_Down,ST_UNPRESSURE);
				SetButtonState(Button_Down,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Down,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_EXIT_WAIT;
				LCD_SetPos(10,0);
				LCD_String(str2[2]); // 3 ,       
			}
			// SELECT
			if(button_state[Button_Select]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Select,ST_LOCKED);
				ResetButtonState(Button_Select,ST_UNPRESSURE);
				SetButtonState(Button_Select,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Select,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM3;
				LCD_SetPos(10,0);
				LCD_String(str2[2]); // 3 ,       
			}
      break;
    case MAIN_MENU_STATE_MM4_WAIT: //  4 
			BlinkItem(3);
			// 
			if(button_state[Button_Right]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Right,ST_LOCKED);
				ResetButtonState(Button_Right,ST_UNPRESSURE);
				SetButtonState(Button_Right,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Right,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM5_WAIT;
				LCD_SetPos(0,1);
				LCD_String(str2[3]); // 4 ,       
			}
			// 
			if(button_state[Button_Left]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Left,ST_LOCKED);
				ResetButtonState(Button_Left,ST_UNPRESSURE);
				SetButtonState(Button_Left,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Left,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM3_WAIT;
				LCD_SetPos(0,1);
				LCD_String(str2[3]); // 4 ,       
			}
			// 
			if(button_state[Button_Up]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Up,ST_LOCKED);
				ResetButtonState(Button_Up,ST_UNPRESSURE);
				SetButtonState(Button_Up,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Up,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM1_WAIT;
				LCD_SetPos(0,1);
				LCD_String(str2[3]); // 4 ,       
			}
			// SELECT
			if(button_state[Button_Select]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Select,ST_LOCKED);
				ResetButtonState(Button_Select,ST_UNPRESSURE);
				SetButtonState(Button_Select,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Select,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM4;
				LCD_SetPos(0,1);
				LCD_String(str2[3]); // 4 ,       
			}
			break;
    case MAIN_MENU_STATE_MM5_WAIT: //  5 
			BlinkItem(4);
			// 
			if(button_state[Button_Right]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Right,ST_LOCKED);
				ResetButtonState(Button_Right,ST_UNPRESSURE);
				SetButtonState(Button_Right,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Right,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_EXIT_WAIT;
				LCD_SetPos(5,1);
				LCD_String(str2[4]); // 5 ,       
			}
			// 
			if(button_state[Button_Left]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Left,ST_LOCKED);
				ResetButtonState(Button_Left,ST_UNPRESSURE);
				SetButtonState(Button_Left,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Left,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM4_WAIT;
				LCD_SetPos(5,1);
				LCD_String(str2[4]); // 5 ,       
			}
			// 
			if(button_state[Button_Up]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Up,ST_LOCKED);
				ResetButtonState(Button_Up,ST_UNPRESSURE);
				SetButtonState(Button_Up,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Up,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM2_WAIT;
				LCD_SetPos(5,1);
				LCD_String(str2[4]); // 5 ,       
			}
			// SELECT
			if(button_state[Button_Select]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Select,ST_LOCKED);
				ResetButtonState(Button_Select,ST_UNPRESSURE);
				SetButtonState(Button_Select,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Select,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM5;
				LCD_SetPos(5,1);
				LCD_String(str2[4]); // 5 ,       
			}			
      break;
    case MAIN_MENU_STATE_EXIT_WAIT: //   EXIT
			BlinkItem(5);
			// 
			if(button_state[Button_Right]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Right,ST_LOCKED);
				ResetButtonState(Button_Right,ST_UNPRESSURE);
				SetButtonState(Button_Right,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Right,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM1_WAIT;
				LCD_SetPos(10,1);
				LCD_String(str2[5]); //  EXIT,       
			}
			// 
			if(button_state[Button_Left]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Left,ST_LOCKED);
				ResetButtonState(Button_Left,ST_UNPRESSURE);
				SetButtonState(Button_Left,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Left,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM5_WAIT;
				LCD_SetPos(10,1);
				LCD_String(str2[5]); //  EXIT,       
			}
			// 
			if(button_state[Button_Up]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Up,ST_LOCKED);
				ResetButtonState(Button_Up,ST_UNPRESSURE);
				SetButtonState(Button_Up,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Up,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_MM3_WAIT;
				LCD_SetPos(10,1);
				LCD_String(str2[5]); //  EXIT,       
			}
			// SELECT
			if(button_state[Button_Select]&ST_UNPRESSURE)
			{
				SetButtonState(Button_Select,ST_LOCKED);
				ResetButtonState(Button_Select,ST_UNPRESSURE);
				SetButtonState(Button_Select,ST_PRESSURE);
				//  
				HAL_Delay(50);
				ResetButtonState(Button_Select,ST_LOCKED);
				main_menu_state = MAIN_MENU_STATE_EXIT;
				LCD_SetPos(10,1);
				LCD_String(str2[5]); //  EXIT,       
			}			
      break;
    case MAIN_MENU_STATE_MM1: //  1
			main_menu_state = MAIN_MENU_STATE_IDLE;
			MainMenuItemProcess(1);
			LCD_Clear();
      break;
    case MAIN_MENU_STATE_MM2: //  2
			main_menu_state = MAIN_MENU_STATE_IDLE;
			MainMenuItemProcess(2);
			LCD_Clear();
      break;
    case MAIN_MENU_STATE_MM3: //  3
			main_menu_state = MAIN_MENU_STATE_IDLE;
			MainMenuItemProcess(3);
			LCD_Clear();
      break;
    case MAIN_MENU_STATE_MM4: //  4
			main_menu_state = MAIN_MENU_STATE_IDLE;
			MainMenuItemProcess(4);
			LCD_Clear();
      break;
    case MAIN_MENU_STATE_MM5: //  5
			main_menu_state = MAIN_MENU_STATE_IDLE;
			MainMenuItemProcess(5);
			LCD_Clear();
      break;
    case MAIN_MENU_STATE_EXIT: //  EXIT
			menu_state = MENU_STATE_IDLE;
			return;
    }
  }
}
//----------------------------------------------
//  
void BlinkItem(uint8_t ind)
{
	if(ind<3) LCD_SetPos(ind*5,0);
	else LCD_SetPos((ind-3)*5,1);
	if(menutim_cnt>200) LCD_String(str2[ind]);
	else LCD_String("    ");
}

//----------------------------------------------
//     
void MainMenuItemProcess(unsigned char ind)
{
  LCD_Clear();
  LCD_SetPos(0,0);
  LCD_String("ITEM ");
  sprintf(str1,"%d",ind);
  LCD_String(str1);
  LCD_String(" Press");
  LCD_SetPos(0,1);
  LCD_String("SELECT from exit");
  //  ,   
  switch (ind)
  {
    case 1:
      //- 1  
      break;
    case 2:
      //- 2  
      break;
    case 3:
      //- 3  
      break;
    case 4:
      //- 4  
      break;
    case 5:
      //- 5  
      break;
  }
  while (1)
  {
    if(button_state[Button_Select]&ST_UNPRESSURE)
    {
			LCD_Clear();
      SetButtonState(Button_Select,ST_LOCKED);
      ResetButtonState(Button_Select,ST_UNPRESSURE);
      SetButtonState(Button_Select,ST_PRESSURE);
      //  
			HAL_Delay(50);
      ResetButtonState(Button_Select,ST_LOCKED);
      return;
    }
		HAL_Delay(50);
  }
}
